#include <windows.h>

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#include <GL/gl.h>


static void print_win_ver()
{
	static OSVERSIONINFO vi;
	vi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&vi);

	int ver = (vi.dwMajorVersion << 8) | vi.dwMinorVersion;

	switch(vi.dwPlatformId)
	{
	case VER_PLATFORM_WIN32_NT:
		if(ver <= 0x0400)
			printf("Win NT v%d.%d ", vi.dwMajorVersion, vi.dwMinorVersion);
		else if(ver == 0x0500)
			printf("Win 2k ");
		else if(ver == 0x0501)
			printf("Win XP ");

		printf("%s (Build %d)", vi.szCSDVersion, vi.dwBuildNumber & 0xffff);
		break;

	case VER_PLATFORM_WIN32_WINDOWS:
		if(ver == 0x0400)
			printf("Win 95");
		else if(ver == 0x040a)
			printf("Win 98");
		else if(ver == 0x045a)
			printf("Win Me");
		break;

	case VER_PLATFORM_WIN32s:
		printf("Win32s");
		break;
	}
}


int main(int argc, char* argv[])
{
	bool error = false;

	freopen("imports.inc", "wt", stdout);


	printf("; System info:\n");
	printf(";   "); print_win_ver(); printf("\n");

	/* setup for opengl (need glGetString) */
	HWND hWnd = CreateWindowEx(0, "EDIT", NULL, WS_POPUP, 0, 0, 1, 1, 0, 0, 0, 0);
	HDC hDC = GetDC(hWnd);
	SetPixelFormat(hDC, 4, NULL);
	wglMakeCurrent(hDC, wglCreateContext(hDC));

	printf(";   %s %s %s\n", glGetString(GL_VENDOR), glGetString(GL_RENDERER), glGetString(GL_VERSION));
	printf("\n");


	HMODULE opengl32 = LoadLibrary("opengl32.dll");

	int TickCount = 0x7ffe0000;
	if(IsBadReadPtr((void*)TickCount, 4))
	{
		fprintf(stderr, "&TickCount != 0x7ffe0000\n");
		error = true;
	}

	/* WinXP gl dll lacks DllInitialize -> all ordinals decreased by one */
	int last_ord = ((GetVersion() & 0xffff) == 0x0105)? 1 : 0;


	printf("opengl32\tequ\t0x%x\n", (int)opengl32);
	printf("\n");
	printf("GetProcAddress\tequ\t0x%x\n", (int)GetProcAddress);
	printf("CreateWindowExA\tequ\t0x%x\n", (int)CreateWindowExA);
	printf("GetMessageA\tequ\t0x%x\n", (int)GetMessageA);
	printf("GetDC\t\tequ\t0x%x\n", (int)GetDC);
	printf("SetPixelFormat\tequ\t0x%x\n", (int)SetPixelFormat);
	printf("\n");
	printf("TickCount\tequ\t0x%x\n", (int)TickCount);
	printf("\n");
	printf("%%assign last_ord %d\n", (int)last_ord);


	fclose(stdout);


	if(!error)
	{
		system("nasm w.asm -o w.exe");
		system("nasm c.asm -o c.com");
		system("apack c.com c.com > NUL");
		system("del w.exe");
		system("c.com");
	}
	else
	{
		fprintf(stderr, "Sorry, the demo cannot run on this computer.\n"\
						"Press any key to exit...\n");
		getch();
	}

	return 0;
}
