; chess demo
;
; Copyright (c) 2003 Jan Wassenberg
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License as
; published by the Free Software Foundation; either version 2 of the
; License, or (at your option) any later version.
;
; This program is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; General Public License for more details.
;
; Contact info:
;   Jan.Wassenberg@stud.uni-karlsruhe.de
;   http://www.stud.uni-karlsruhe.de/~urkt/


bits 32
org 0x400000


;############################################################################################################################
; header
;############################################################################################################################

%define rva(addr) (addr - 0x400000)

		db	'MZ'				; e_magic
		db	'.',0				;   dropped file name
		dd	'PE'				; Signature
		dw	0x014c				; Machine = x86
		dw	1				; NumberOfSections
		dd	0,0,0
		dw	0x0070				; SizeOfOptionalHeader
		dw	0x010f				; Characteristics = 32 bit exe
		dw	0x010b				; Magic
		db	'glu32.dll',0			;   Name (RVA 30)
		dd	0
		dd	rva(start)			; AddressOfEntryPoint
		dd	0,0
		dd	0x400000			; ImageBase
		dd	4				; SectionAlignment, e_lfanew
		dd	4				; FileAlignment
		dd	0,0
		dw	4				; MajorSubsystemVersion
		db	'EDIT',0			;   wnd class name (RVA 78)
		db	0
		dd	0x10000				; SizeOfImage (virtual)
		dd	0xa4				; SizeOfHeaders
		dd	0
		dw	2				; Subsystem = WIN32_GUI
		dw	0
		dd	0x400000			; SizeOfStackReserve
		dd	0x400000			; SizeOfStackCommit
		dd	30				;   Name (RVA 108)
		dd	rva(imp_tbl)			;   FirstThunk
		dd	0
		dd	2				; NumberOfRvaAndSizes (# data dirs)
		dd	0				; Export VirtualAddress
		dd	0				; Export Size, End Import
		dd	96				; Import VirtualAddress
		dd	40				; Import Size
		dd	0,0
		dd	0				; VirtualSize
		dd	0				; VirtualAddress
		dd	0x10000				; SizeOfRawData				FIXME?
		dd	0				; PointerToRawData


;############################################################################################################################
; code
;############################################################################################################################


start:


;____________________________________________________________________________________________________________________________
;
; win init
;____________________________________________________________________________________________________________________________
;

%include "imports.inc"


; import gl functions
	mov		esi, ord_tbl
	mov		edi, ogl_funcs
	push		byte num_ords
	pop		ebp
	xor		ebx, ebx			; (xchg eax, ebx if eax == 0)?
.1:	xor		eax, eax
	lodsb						; delta to next ordinal
	add		ebx, eax			; ebx = current ordinal
	push		ebx
	push		opengl32
	call		GetProcAddress
	stosd
	dec		ebp
	jnz		.1

; HWND hWnd = CreateWindowEx(0, "EDIT", 0, WS_POPUP|WS_VISIBLE, 0, 0, 1024, 768, 0, 0, 0, 0);
	push		ebp				; 0
	push		ebp
	push		ebp
	push		ebp
	cdq						; edx = 0
	mov		dh, 3
	push		edx				; 768
	mov		dh, 4
	push		edx				; 1024
	push		ebp
	push		ebp
	push		0x90000000			; WS_POPUP|WS_VISIBLE				5
	push		ebp
	push		0x0040004e			; -> class name ("EDIT")
	push		ebp
	call		CreateWindowExA

; hDC = GetDC(hWnd);
	push		eax
	call		GetDC
	stosd
	mov		ebp, edi			; ebp -> BSS (after func tbl + hDC)
	xchg		eax, ebx


; > ebx = hDC
; > esi -> GL state data
; > ebp -> BSS


; .BSS
%define hDC		ebp-4
%define msg.message	ebp+4
%define fx		ebp+44
%define fz		ebp+48
%define ty		ebp+52
%define p_data		ebp+56


; .DATA
%define sq_color	esi				; (sq_color[white] == piece_color[white])
%define piece_color	esi
%define _7.5		esi+12
%define _0.5		esi+16
%define _SPEED		esi+20
%define _0.07		esi+22
%define f		esi+26
%define t		esi+30
%define _PI_4		esi+34
%define pmv		esi+38
%define move_start	esi+42
%define move_len	esi+46
%define ofs_cnt		esi+50
%define board		esi+62


; SetPixelFormat(hDC, pf, &pfd);
	push		ebp
	push		byte 4				; opengl, double buffered + zbuffer
	push		ebx
	call		SetPixelFormat

; hGLRC = wglCreateContext(hDC);
	push		ebx
	call		[byte ebp+wglCreateContext]

; wglMakeCurrent(hDC, hGLRC);
	push		eax
	push		ebx
	call		[byte ebp+wglMakeCurrent]


;____________________________________________________________________________________________________________________________
;
; GL state
;____________________________________________________________________________________________________________________________
;

; > ebx = 0
%macro push_doubles 1-*					; C params: pushed right-to-left
%rep %0
%rotate -1
	push		dword %1
	push		ebx
%endrep
%endmacro

%define _0 ebx
_1.33		equ	0x3ff55555
_4		equ	0x40100000
_13		equ	0x402a0000
_15.5		equ	0x402f0000
_30		equ	0x403e0000


	xor		ebx, ebx

; glMatrixMode(GL_PROJECTION);
; > eax = 1
; < edi = 0x1701
	mov		ah, 0x17
	xchg		eax, edi
	push		edi				; GL_PROJECTION
	call		[byte ebp+glMatrixMode]

; gluPerspective(30., 4./3., 10., 100.);
push_doubles _30, _1.33, _4, _30
	call		[byte ebp+gluPerspective]

; glMatrixMode(GL_MODELVIEW);
; > edi = 0x1701
	dec		edi
	push		edi				; GL_MODELVIEW
	call		[byte ebp+glMatrixMode]

; gluLookAt(4.,13.,15.5, 4.,0,4., 0,1.,0);
push_doubles _4, _13, _15.5, _4, _0, _4, _0, _4, _0
	call		[byte ebp+gluLookAt]

; glEnable(GL_LIGHT0);
	mov		di, 0x4000			;						4
	push		edi
	call		[byte ebp+glEnable]

; glLightfv(GL_LIGHT0, GL_AMBIENT, light_amb);
; glLightfv(GL_LIGHT0, GL_POSITION, light_dir);

%macro gl_light 0
	push		esi
	add		esi, byte 16
	push		ebx
	push		edi
	call		[byte ebp+glLightfv]
%endmacro

	mov		bh, 0x12			; GL_AMBIENT
gl_light
	mov		bl, 0x03			; GL_POSITION
gl_light


; glMaterialfv(GL_FRONT, GL_SPECULAR, mat_spec);
	dec		ebx
	push		esi				; &mat_spec
	add		esi, byte 16
	push		ebx				; GL_SPECULAR
	push		dword 0x404			; GL_FRONT					5
	call		[byte ebp+glMaterialfv]

; glEnable(GL_DEPTH_TEST);
; glEnable(GL_COLOR_MATERIAL);
; glEnable(GL_LIGHTING);

%macro gl_enable 1
	mov		bl, %1
	push		ebx
	call		[byte ebp+glEnable]
%endmacro

	mov		bh, 0x0b
gl_enable 0x71						; GL_DEPTH_TEST
gl_enable 0x57						; GL_COLOR_MATERIAL
gl_enable 0x50						; GL_LIGHTING


;_______________________________________________________
;
; unpack piece data
;_______________________________________________________
;

	mov		ecx, 303
	lea		edi, [p_data]			; (ebp relative)
.3:	fild		word [esi+ecx]			; 2940
	xor		eax, eax
	lodsb						; eax = idx[i]
	fidivr		word [p_tbl + eax*2]		; tbl[idx[i]] / 2940
	fstp		dword [edi]
	scasd						; edi += 4
	loop		.3
	lodsw						; esi += 2 (skip 2940)




main_loop:


;____________________________________________________________________________________________________________________________
;
; move logic
;____________________________________________________________________________________________________________________________
;

%define SPEED 22					; [10 ms / square]
%define DELAY byte 46					; delay before move begin [10 ms]
%define CTIME byte 46					; capture time [10 ms]

;_______________________________________________________
;
; calculate fx, fz, ty
;_______________________________________________________
;

; get elapsed time / capture progress
	mov		eax, [TickCount]
	sub		eax, [move_start]		; eax = et
	cdq
	sub		eax, DELAY
	cmovs		eax, edx			; if(et < DELAY) et = 0
	mov		ebx, [move_len]
	sub		ebx, byte SPEED
	sub		ebx, eax			; ebx = time before capture
	push		ebx				; capture progress (0 .. -CTIME)
	jns		.move1				; ebx > 0
	mov		ecx, [t]
	mov		cl, [board+ecx]			; ecx = board[t]
	jecxz		.move1				; empty? yes - normal move

; capture
	add		ebx, CTIME			; capture over?
	js		.move2				; yes
	fild		dword [esp]			; progress
	fmul		dword [_0.07]			; * tdy
	fstp		dword [ty]
	add		eax, ebx			; don't move fpiece during capt
.move2:	sub		eax, CTIME
.move1:

	pop		ecx
	xchg		eax, edi			; edi = et


;_______________________________________________________
;
; move init
;_______________________________________________________
;

	mov		edx, [pmv]

; if(move_over) pmv++;
	add		ebx, byte SPEED			; time up?
	jns		$+4				; no
	inc		edx
	inc		edx
	mov		[pmv], edx

; extract f,t
	movzx		ecx, word [edx]			; mv	
	mov		eax, ecx
	shr		ecx, 6				; f
	and		eax, byte 0x3f			; t

; calc dx, dz
	pusha						; save f, t
	mov		ebx, eax
	and		al, 7				; tx
	shr		ebx, 3				; tz
	mov		edx, ecx
	and		dl, 7				; fx (st3)
	shr		ecx, 3				; fz
	sub		eax, edx			; dx
	sub		ebx, ecx			; dz (st0)
	push		ebx
	push		eax
	push		ecx
	push		edx
%rep 4
	fild		dword [esp]
	pop		eax
%endrep
	popa						; ecx = f, eax = t
	fld		st0
	fmul 		st0, st0
	fld		st2
	fmul 		st0, st0
	faddp		st1, st0
	fsqrt						; move distance
	fimul		word [_SPEED]
	fist		dword [move_len]
	fdiv		st2, st0
	fdivp		st1, st0


	test		ebx, ebx
	jns		.no_init

; w q castle
	cmp		al, 2				; t == c1? (w q castle)
	jnz		.2				; no
	mov		dword [board], 0x04000000	; (king moved normally)
.2:

; update board
	cdq
	xchg		ecx, [f]			; ecx <- f; f <- f; 
	xchg		eax, [t]			; eax <- t; t <- t;
	xchg		dl, [board+ecx]			; dl <- board[f]; board[f] <- 0
	xchg		eax, ecx			; ecx <- eax (t)
	xchg		dl, [board+ecx]			; board[t] = dl

; move_start = GetTickCount();
	push		dword [TickCount]
	pop		dword [move_start]

	xor		edi, edi			; et = 0
	mov		[ty], edi			; reset ty

.no_init:


; update position
	push		edi
	fild		dword [esp]			; et
	pop		ecx
	fmul		st2, st0			; z offset
	fmulp		st1, st0			; x offset
	faddp		st2, st0			; z
	faddp		st2, st0			; x
	fstp		dword [fz]
	fstp		dword [fx]


;____________________________________________________________________________________________________________________________
;
; gfx
;____________________________________________________________________________________________________________________________
;

; glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	push		dword 0x4100			; GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT
	call		[byte ebp+glClear]


; for(int z = 0; z < 8; z++)
;   for(int x = 0; x < 8; x++)
;   {
	push		byte 7
	pop		edi
	xor		ebx, ebx
sq_loop:


;_______________________________________________________
;
; draw piece
;_______________________________________________________
;

	pusha

	call		[byte ebp+glPushMatrix]

; coords
	lea		eax, [edi*8+ebx]		; eax = sq
	fld		dword [fx]
	fld		dword [fz]
	cmp		eax, [f]			; sq == f?
	je		.1
	fcompp
	push		edi
	push		ebx
	fild		dword [esp]			; sq.x
	pop		ecx
	fild		dword [esp]			; sq.z
	pop		ecx
.1:

	mov		bl, [board+eax]			; ebx = piece | (color << 7)

; glTranslatef(x+.5f, y, 7.5f-z);
	fsubr		dword [_7.5]			; 7.5f-z
	push		eax				; placeholder
	fstp		dword [esp]			; 7.5f-z

	cmp		eax, [t]			; sq == t?
	cdq						;  no  - y := 0
	cmove		edx, [ty]			;  yes - y := ty
	push		edx

	fadd		dword [_0.5]			; x+0.5f
	push		eax				; placeholder
	fstp		dword [esp]			; x+0.5f
	call		[byte ebp+glTranslatef]

; turn black knights around (facing forward)

; if(piece == bknight)
	cmp		bl, 0x82			; black knight
	jne		.no_rot

;   glRotatef(180, 0, 1, 0);
	cdq
	push		edx
	mov		ecx, 0x43340000			; 180.f
	push		ecx
	push		edx
	push		ecx
	call		[byte ebp+glRotatef]
.no_rot:

; glColor4ubv(piece_color[piece >> 7]);
	btr		ebx, 7				; ebx = piece, cf = color
	cdq
	rcl		edx, 1				; edx = color
	lea		eax, [piece_color + edx*8]	; &piece_color[color]
	push		eax
	call		[byte ebp+glColor4ubv]

	dec		ebx
	js		near .no_draw_piece		; piece == 0? yes - quit

	push		byte 8				; GL_QUAD_STRIP
	call		[byte ebp+glBegin]


;_______________________________________________________
;
; draw knight superstructure
;_______________________________________________________
;

	dec		ebx
	jnz		.not_knight

	lea		edi, [p_data]			; edi -> knight data

	mov		bl, 20
.2:	push		dword [edi]
	push		dword [edi+4]
	push		dword [_0.07]
	call		[byte ebp+glVertex3f]
	xor		byte [_0.07+3], 0x80		; flip sign bit of 0.07f
	js		.2

	scasd
	scasd
	dec		ebx
	jnz		.2

.not_knight:


;_______________________________________________________
;
; rotated base
;_______________________________________________________
;

	lea		edi, [ofs_cnt + ebx*2+2]	; -> ofs_cnt[piece]
	movzx		eax, byte [edi]			; ofs[piece] / 8
	movzx		ebx, byte [edi+1]		; cnt[piece]
	lea		edi, [p_data + eax*8]		; -> p_data[piece]
	
.outer:
	fldz						; init angle
	mov		bh, 8				; 8x Pi/4

.inner:

; glNormal3f(c, 0, s);
	fld		st0
	fsincos
	fld		st1
	push		eax
	fstp		dword [esp]
	push		byte 0
	push		eax
	fst		dword [esp]
	call		[byte ebp+glNormal3f]

; glVertex3f(c*f[0], f[1], s*f[0]);
%macro rot_vtx 0
	fld		dword [edi]
	fld		st0
	fmul		st3
	push		eax
	fstp		dword [esp]
	scasd
	push		dword [edi]
	fmul		st1
	push		eax
	fstp		dword [esp]
	call		[byte ebp+glVertex3f]
%endmacro

	push		edi
rot_vtx
	scasd
rot_vtx
	pop		edi

	fcompp
	fadd		dword [_PI_4]			; angle += Pi/4

	dec		bh
	jnz		.inner

	fstp		st0
	scasd
	scasd

	dec		ebx
	jnz		.outer

	call		[byte ebp+glEnd]

.no_draw_piece:
	popa

	call		[byte ebp+glPopMatrix]


;_______________________________________________________
;
; draw board square
;_______________________________________________________
;

	push		byte 7				; GL_QUADS
	call		[byte ebp+glBegin]

;     glColor4ubv(sq_color[(x+z)&1]);
	lea		eax, [ebx+edi]
	and		eax, byte 1
	lea		eax, [sq_color + eax*4]		; &sq_color[color]
	push		eax
	call		[byte ebp+glColor4ubv]

;     glVertex3i(x,   0, z);
;     glVertex3i(x+1, 0, z);
;     glVertex3i(x+1, 0, z+1);
;     glVertex3i(x,   0, z+1);

%macro q_vtx 0
	push		ebx				; z
	push		byte 0				; y
	push		edi				; x
	call		[byte ebp+glVertex3i]
%endmacro

q_vtx
	inc		edi
q_vtx
	inc		ebx
q_vtx
	dec		edi
q_vtx

	call		[byte ebp+glEnd]

	and		ebx, byte 7
	jnz		$+3				; ebx != 0: jmp to sq_loop
	dec		edi
	jns		near sq_loop

;   }


; SwapBuffers(hDC);
	push		dword [hDC]
	call		[byte ebp+wglSwapBuffers]

; GetMessage(&msg, 0, 0, 0);
	cdq
	push		edx
	push		edx
	push		edx
	push		ebp				; -> msg
	call		GetMessageA

; if(msg.message == WM_KEYDOWN) exit();
	cmp		word [msg.message], 0x100	; msg == WM_KEYDOWN?
	jne		near main_loop
	ret


;############################################################################################################################
; data
;############################################################################################################################

num_ords	equ	18				; keep in sync w/ ord_tbl

%macro ORD 2
%1		equ	($-ord_tbl - num_ords-1)*4	; offset in function table
		db	%2-last_ord			; ordinal delta
%assign last_ord %2
%endmacro

; manually imported opengl32 functions
ord_tbl:
ORD glBegin,		12
ORD glClear,		18
ORD glColor4ubv,	52
ORD glEnable,		81
ORD glEnd,		83
ORD glLightfv,		160
ORD glMaterialfv,	180
ORD glMatrixMode,	183
ORD glNormal3f,		191
ORD glPopMatrix,	214
ORD glPushMatrix,	219
ORD glRotatef,		257
ORD glTranslatef,	318
ORD glVertex3f,		329
ORD glVertex3i,		331
ORD wglCreateContext,	347
ORD wglMakeCurrent,	358
ORD wglSwapBuffers,	363




		dd	0.95, 0.95, 0.95, 1.0		; light_amb
		dd	10.0, 2.0, 4.0, 0.0		; light_dir

		dd	0.14, 0.14, 0.14, 1.0		; mat_spec


; indices into p_tbl
	; knight's head
		db	32,78,57,85,86,00,17,42,01,87,88,89,88,89,90,91
		db	90,91,92,42,92,42,92,56,92,56,81,00,81,00,93,49
		db	94,95,94,95,96,78,01,78

	; bases

	; pawn
		db	01,00,02,03,04,05,06,07,08,09,06,10,04,11,04,11
		db	08,12,08,13,14,13,14,13,15,16,15,16,17,16,17,16
		db	18,18,19,20,19,14,21,14,21,22,19,01,00

	; knight
		db	23,24,25,24,25,26,25,26,25,27,28,27,29,30,30,31
		db	32,31,32,31,14,33,34,33,22,31,22,31,01,31,01,00
		db	35,01,36

	; bishop
		db	37,38,22,39,22,39,32,40,41,42,20,43,20,43,44,45
		db	20,00,20,00,20,46,20,46,08,47,15,48,15,48,27,49
		db	50,51,27,52,14,53,14,53,32,54,32,54,17,54,17,54
		db	30,30,31,32,31,32,31,14,33,34,33,22,31,01,00

	; rook
		db	40,01,00,55,00,55,00,55,56,55,56,57,56,57,56,57
		db	56,55,46,55,46,17,46,17,46,27,58,27,58,59,58,59
		db	58,30,30,31,32,31,32,31,14,33,34,33,22,31,01,00

	; king/queen
		db	60,01,60,14,61,24,62,14,63,14,63,17,64,17,64,30
		db	64,57,64,57,65,57,65,26,66,67,39,67,39,26,68,17
		db	69,17,69,17,40,70,40,71,72,71,72,73,72,74,75,32
		db	76,32,77,26,78,27,78,71,78,54,30,58,57,58,32,58
		db	32,29,79,58,14,58,01,00

		dw	2940				; p_tbl divisor


; after init: esi -> .DATA

; colors (ub rgba)
		db	90, 90, 90, 255			; white piece & square
		db	27, 27, 27, 255			; black square
		db	13, 13, 13, 255			; black piece

		dd	7.5
		dd	0.5
		dw	SPEED
		dd	0.07				; knight head width, tdy
		dd	0				; f
		dd	0				; t
		dd	0.78539816			; Pi/4
		dd	mvs-2				; pmv
		dd	0				; move_start
		dd	0				; move_len

; byte offset/8 into p_data and loop count
		db	20,21, 43,14, 59,31, 92,22, 116,34, 118,32

; board
		db	0x04,0x02,0x03,0x05,0x06,0x03,0x02,0x04
		db	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
		db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
		db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
		db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
		db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
		db	0x81,0x81,0x81,0x81,0x81,0x81,0x81,0x81
		db	0x84,0x82,0x83,0x85,0x86,0x83,0x82,0x84

; 'dictionary'
p_tbl:
		dw	2100,0000,0150,2070,0277,1985,0362,1858
		dw	0391,1707,1557,1430,1330,1259,0210,0364
		dw	0720,0384,0469,0658,0315,0588,0104,1365
		dw	0139,1085,0455,0490,0979,0770,0595,0735
		dw	0350,0664,0244,3290,3219,0175,3115,3044
		dw	2729,0448,2449,2169,0405,2134,1889,1854
		dw	1820,1749,0517,1714,1680,1609,0805,0419
		dw	2240,0559,0839,0511,4199,4094,3990,3919
		dw	3779,3499,3324,0387,2975,2904,0385,0524
		dw	2555,0525,0644,2484,2415,2380,1119,0279
		dw	4900,-139,4270,4549,-490,1960,0609,2800
		dw	-210,3010,-350,2695,-595,-315,-559,1645
		dw	-455


; Morphy vs Isouard & Brunswick (Paris 1858)
; format:
;   bits 6-b: 'from' square
;   bits 0-5: 'to' square
mvs:
		dw	0796,3364,0405,3307,0731,3742,1764,1941
		dw	0213,2788,0346,4013,1361,3828,0082,3242
		dw	0166,3169,1185,2721,1697,3699,0258,3643
		dw	0243,3827,0451,3372,2163,2931,1145,3321
		dw	0251


;-------------------------------------------------------;
func_tbl:

%macro IMP 2
%1		equ	$-func_tbl-(num_ords+1+3)*4	; offset relative to ebp = ogl_funcs
		dd	0x80000000+%2			; ordinal
%endmacro

; imports from glu32.dll
imp_tbl:
IMP gluLookAt,		22
IMP gluPerspective,	33
		dd	0				; end imp tbl

ogl_funcs:

;		resd	num_ords
;		resd	1				; hDC
; ebp ->
;		BSS
